;**************INSTRUCTIONS TO RUN THIS PROGRAM*********************
;1. INSERT THE DATA FILE NAME ON THE PROGRAM LINE #7
;2. INSERT THE RMF FILE NAME ON THE PROGRAM LINES #42 AND #82
;3. START IDL PROGRAM BY ENTERING .r DG.PRO

;********************************************************************
INPUTFILE='YYYY_MM_DDThh_mm.DAT'
;********************************************************************

XSM_SPEC_TABLE=MRDFITS(INPUTFILE, 1)
SPEC=XSM_SPEC_TABLE.SPECTRUM

N=N_ELEMENTS(SPEC(0,*))
SD=LONARR(512,N)

FOR I=0, N-1 DO BEGIN
SD(*,I)=SPEC(*,I)
ENDFOR

CHANNEL=INDGEN(512)

PDD_0=STRARR(5)
PDD_0(0)='SIMPLE  =                    T / file does conform to FITS standard'
PDD_0(1)='BITPIX  =                    8 / number of bits per data pixel'
PDD_0(2)='NAXIS   =                    0 / number of data axes'
PDD_0(3)='EXTEND  =                    T / FITS dataset may contain extensions'
PDD_0(4)='END'

OUTBEG = 'XSM_'
OUTEND = '.DAT'
RMF_BEG = 'XSM_'
RMF_END = '.RMF'
ARF_END = '.ARF'

FOR K=0, N-1 DO BEGIN
;FOR K=10, 11 DO BEGIN
OUTFILE=OUTBEG+strtrim(string(K),2)+OUTEND
FXWRITE, OUTFILE, PDD_0

;******INSERT THE CORRESPONDING RMF FILE NAME ON THE ROW BELOW******
;*******************************************************************
RMFFILE='YYYY_MM_DDThh_mm.RMF'  
;********************************************************************

;RMF_BEG+strtrim(string(K),2)+RMF_END
ARFFILE=RMF_BEG+strtrim(string(K),2)+ARF_END
DATAFILE=OUTBEG+strtrim(string(K),2)+OUTEND

PDD_1=STRARR(40)

PDD_1(0)='XTENSION= ''BINTABLE''           / binary table extension'
PDD_1(1)='BITPIX  =                    8 / 8-bit bytes'
PDD_1(2)='NAXIS   =                    2 / 2-dimensional binary table'
PDD_1(3)='NAXIS1  =                    6 / width of table in bytes'
PDD_1(4)='NAXIS2  =                  512 / number of rows in table'
PDD_1(5)='PCOUNT  =                    0 / size of special data area'
PDD_1(6)='GCOUNT  =                    1 / one data group (required keyword)'
PDD_1(7)='TFIELDS =                    2 / number of fields in each row'
PDD_1(8)='TTYPE1  = ''CHANNEL ''           / label for field'
PDD_1(9)='TFORM1  = ''I     ''             / format of field: 2 b'
PDD_1(10)='TTYPE2  = ''COUNTS  ''           / label for field'
PDD_1(11)='TFORM2  = ''J     ''             / format of field: 4 b'
PDD_1(12)='TUNIT2  = ''COUNTS ''            / unit of field'
PDD_1(13)='EXTNAME = ''SPECTRUM''           / name of this binary table extension'
PDD_1(14)='HDUCLASS= ''OGIP    ''           / format conforms to OGIP/GSFC conventions'
PDD_1(15)='HDUCLAS1= ''SPECTRUM''           / extension contains a spectrum'
PDD_1(16)='HDUCLAS3= ''COUNT  ''            / spectrum is counts'
PDD_1(17)='HDUVERS = ''1.2.1  ''            / version number of the format'
PDD_1(18)='TELESCOP= ''SMART-1 ''           / telescope (mission) name'
PDD_1(19)='INSTRUME= ''XSM     ''           / instrument name'
PDD_1(20)='FILTER  = ''none    ''           / instrument filter used'
PDD_1(21)='EXPOSURE=           1.6000E+01 / Exposure time'
PDD_1(22)='BACKSCAL=           1.0000E+00 / Background scale factor'
PDD_1(23)='AREASCAL=           1.0000E+00 / Area scale factor'
PDD_1(24)='CORRSCAL=           1.0000E+00 / Correction scale factor'
PDD_1(25)='OBJECT  = ''SUN    ''            / object observed'
PDD_1(26)='BACKFILE= ''none   ''            / bgrd FITS file'
PDD_1(27)='CORRFILE= ''none   ''            / Correction FITS file' 

;**********INSERT THE CORRESPONDING RMF FILE NAME ON THE ROW BELOW*******************
;************************************************************************************
PDD_1(28)='RESPFILE= ''YYYY_MM_DDThh_mm.RMF''       / Redistribution matrix file (RMF)' 
;************************************************************************************

;PDD_1(29)='ANCRFILE= ''YYYY_MM_DDThh_mm.ARF''  / Anc. Resp. file (ARF)
;PDD_1(28)='RESPFILE= ''' + RMFFILE + '''    / Redistribution matrix file (RMF)'
PDD_1(29)='ANCRFILE= ''' + ARFFILE + '''    / Anc. Resp. file (ARF)
PDD_1(30)='CHANTYPE= ''PHA    ''            / Chan. assigned by det electronics'
PDD_1(31)='DETCHANS=                  512 / Total no. detector channels available'
PDD_1(32)='TLMIN1  =                    0 / Minimum value legally allowed in column 1'
PDD_1(33)='TLMAX1  =                  511 / Maximum value legally allowed in column 1'
PDD_1(34)='STAT_ERR=                    0 / Stat error not used.'
PDD_1(35)='POISSERR=                    T / Pois. err. assumed'
PDD_1(36)='SYS_ERR =                    0 / No sys. err spcf.'
PDD_1(37)='GROUPING=                    0 / No grpng of data spcf.'
PDD_1(38)='QUALITY =                    0 / No data qual info spcf.'
PDD_1(39)='END'

FXBCREATE, UNIT_1, OUTFILE, PDD_1, errmsg=errmsg

FOR J=1, 512 DO BEGIN
FXBWRITE, UNIT_1, CHANNEL(J-1), 1, J
FXBWRITE, UNIT_1, SD(J-1,K), 2, J
ENDFOR
FXBFINISH, UNIT_1
PRINT, K
ENDFOR
END


